# Baselet: `Base` API optimized for tuples

[![GitHub Actions](https://github.com/tkf/Baselet.jl/workflows/Run%20tests/badge.svg)](https://github.com/tkf/Baselet.jl/actions?query=workflow%3A%22Run+tests%22)
[![Aqua QA](https://img.shields.io/badge/Aqua.jl-%F0%9F%8C%A2-aqua.svg)](https://github.com/tkf/Aqua.jl)

## API

* `Baselet.$f` provides a possibly-optimized version of `$f` exported
  from `Base` (e.g., `Baselet.sort(::Tuple)`).

* `Baselet.Specialized.$f` provides a function `$f` with a subset of
  API from `Base.$f` that is _guaranteed_ to have optimized
  specializations (e.g., `Baselet.Specialized.sort(::Tuple)`).

* `Baselet.$f` fallbacks to `Base.$f` if associated
  `Baselet.Specialized.$f` is not found.  For example,
  `Baselet.sort(::Vector)` just calls `Base.sort(::Vector)`.

The list of supported functions can be found by typing
`Baselet.Specialized.` + <kbd>TAB</kbd> in the REPL:

```julia
julia> using Baselet

julia> Baselet.Specialized.
accumulate   cumprod      findall      flatten      isdisjoint   sort
all          cumsum       findfirst    foreach      issubset     symdiff
any          enumerate    findlast     getindex     maximum      union
argmax       extrema      findmax      in           minimum      unique
argmin       filter       findmin      intersect    setdiff      zip
```

"""
    Baselet.Specialized

Functions that are specialized in Baselet.jl.
"""
baremodule Specialized
function getindex end
function filter end
function zip end
function enumerate end
function accumulate end
function cumsum end
function cumprod end
function flatten end
function foreach end
function any end
function all end
function findfirst end
function findlast end
function findall end
function findmax end
function findmin end
function argmax end
function argmin end
function maximum end
function minimum end
function extrema end
function in end
function unique end
function union end
function intersect end
function setdiff end
function symdiff end
function issubset end
function isdisjoint end
function sort end
end

# Vendoring `Base.afoldl`
afoldl(op,a) = a
afoldl(op,a,b) = op(a,b)
afoldl(op,a,b,c...) = afoldl(op, op(a,b), c...)
function afoldl(op,a,b,c,d,e,f,g,h,i,j,k,l,m,n,o,p,qs...)
    y = op(op(op(op(op(op(op(op(op(op(op(op(op(op(op(a,b),c),d),e),f),g),h),i),j),k),l),m),n),o),p)
    for x in qs; y = op(y,x); end
    y
end

@inline getindex(x, inds...) = Base.getindex(x, inds...)
@def getindex(xs::Tuple, ind::UnitRange) = ntuple(i -> xs[ind[i]], length(ind))

@inline filter(f, xs) = Base.filter(f, xs)
@def filter(f::F, xs::Tuple) where {F} =
    afoldl((ys, x) -> f(x) ? (ys..., x) : ys, (), xs...)

zip(x, xs...) = Base.zip(x, xs...)

# Not using `zip(tuples::NTuple{N,Any}...)` to avoid having unbound
# type parameter.
@def function zip(x::NTuple{N,Any}, xs::NTuple{N,Any}...) where {N}
    tuples = (x, xs...)
    return ntuple(i -> map(t -> t[i], tuples), N)
end

@inline flatten(itr) = Iterators.flatten(itr)

@def flatten(xs::Tuple) = _flatten(xs...)
@inline _flatten() = ()
@inline _flatten(x::Tuple, xs::Tuple...) = (x..., _flatten(xs...)...)

@inline enumerate(itr) = Base.enumerate(itr)

@def enumerate(xs::Tuple) = Specialized.zip(ntuple(identity, length(xs)), xs)

struct _InitialValue end

struct BottomRF{T}
    rf::T
end

@inline (op::BottomRF)(::_InitialValue, x) = Base.reduce_first(op.rf, x)
@inline (op::BottomRF)(acc, x) = op.rf(acc, x)

@inline accumulate(args...; kw...) = Base.accumulate(args...; kw...)

@def function accumulate(op::F, xs::Tuple; init = _InitialValue()) where {F}
    rf = BottomRF(op)
    ys, = afoldl(((), init), xs...) do (ys, acc), x
        acc = rf(acc, x)
        (ys..., acc), acc
    end
    return ys
end

@inline cumsum(args...; kw...) = Base.cumsum(args...; kw...)
@def cumsum(xs::Tuple) = Specialized.accumulate(Base.add_sum, xs)

@inline cumprod(args...; kw...) = Base.cumprod(args...; kw...)
@def cumprod(xs::Tuple) = Specialized.accumulate(Base.mul_prod, xs)

@inline foreach(f, xs, rest...) = Base.foreach(f, xs, rest...)

# Not using `@def` so that `Specialized.foreach` is always defined via `foldl`.
@inline foreach(f, xs::Tuple, rest::Tuple...) = Specialized.foreach(f, xs, rest...)
@inline Specialized.foreach(f, xs) = afoldl((_, x) -> (f(x); nothing), nothing, xs...)
@inline Specialized.foreach(f, xs, rest...) =
    afoldl((_, args) -> (f(args...); nothing), nothing, zip(xs, rest...)...)
# https://github.com/JuliaLang/julia/pull/31901

@inline any(f, itr) = Base.any(f, itr)
@inline any(itr) = Base.any(itr)

@def any(xs::Tuple) = _any(identity, xs...)
@def any(f::F, xs::Tuple) where {F} = _any(f, xs...)
@inline _any(f) = false
@inline function _any(f::F, x, xs...) where {F}
    y = f(x)
    y === true && return true
    return y | _any(f, xs...)
end

@inline all(f, itr) = Base.all(f, itr)
@inline all(itr) = Base.all(itr)

@def all(xs::Tuple) = _all(identity, xs...)
@def all(f::F, xs::Tuple) where {F} = _all(f, xs...)
@inline _all(f) = true
@inline function _all(f::F, x, xs...) where {F}
    y = f(x)
    y === false && return false
    return y & _all(f, xs...)
end

@inline findfirst(xs) = Base.findfirst(xs)
@inline findfirst(f, xs) = Base.findfirst(f, xs)
@def findfirst(xs::Tuple{Vararg{Bool}}) = _findfirst(identity, 1, xs...)
@def findfirst(f::F, xs::Tuple) where {F} = _findfirst(f, 1, xs...)
@inline _findfirst(f, n) = nothing
@inline _findfirst(f::F, n, x, xs...) where {F} = f(x) ? n : _findfirst(f, n + 1, xs...)

@inline findlast(xs) = Base.findlast(xs)
@inline findlast(f, xs) = Base.findlast(f, xs)
@def findlast(xs::Tuple{Vararg{Bool}}) = _findlast(identity, 1, xs...)
@def findlast(f::F, xs::Tuple) where {F} = _findlast(f, 1, xs...)
@inline _findlast(f, n) = nothing
@inline function _findlast(f::F, n, x, xs...) where {F}
    i = _findlast(f, n + 1, xs...)
    i === nothing || return i
    return f(x) ? n : nothing
end

@inline findall(xs) = Base.findall(xs)
@inline findall(f, xs) = Base.findall(f, xs)
@def findall(xs::Tuple{Vararg{Bool}}) = _findall(identity, 1, xs...)
@def findall(f::F, xs::Tuple) where {F} = _findall(f, 1, xs...)
@inline _findall(f, n) = ()
@inline _findall(f, n, x, xs...) = ((f(x) ? (n,) : ())..., _findall(f, n + 1, xs...)...)

@inline findmax(args...; kw...) = Base.findmax(args...; kw...)
@def findmax(xs::Tuple{}) = throw(ArgumentError("collection must be non-empty"))
@def findmax(xs::Tuple) = _findmax(zip(xs, ntuple(identity, length(xs)))...)
@inline _findmax(ans) = ans
@inline function _findmax((x, i), (y, j), rest...)
    x != x && return (x, i)
    return _findmax(y != y || isless(x, y) ? (y, j) : (x, i), rest...)
end

@inline findmin(args...; kw...) = Base.findmin(args...; kw...)
@def findmin(xs::Tuple{}) = throw(ArgumentError("collection must be non-empty"))
@def findmin(xs::Tuple) = _findmin(zip(xs, ntuple(identity, length(xs)))...)
@inline _findmin(ans) = ans
@inline function _findmin((x, i), (y, j), rest...)
    x != x && return (x, i)
    return _findmin(y != y || isless(y, x) ? (y, j) : (x, i), rest...)
end

@inline argmax(args...; kw...) = Base.argmax(args...; kw...)
@def argmax(xs::Tuple) = Specialized.findmax(xs)[2]

@inline argmin(args...; kw...) = Base.argmin(args...; kw...)
@def argmin(xs::Tuple) = Specialized.findmin(xs)[2]

@inline maximum(args...; kw...) = Base.maximum(args...; kw...)
@def maximum(xs::Tuple) = Specialized.findmax(xs)[1]

@inline minimum(args...; kw...) = Base.minimum(args...; kw...)
@def minimum(xs::Tuple) = Specialized.findmin(xs)[1]

@inline extrema(args...; kw...) = Base.extrema(args...; kw...)
@def extrema(xs::Tuple{}) = throw(ArgumentError("collection must be non-empty"))
@def extrema(xs::Tuple) = Specialized.extrema(identity, xs)
@def extrema(f, xs::Tuple{}) = throw(ArgumentError("collection must be non-empty"))
@def function extrema(f::F, xs::Tuple) where {F}
    x = xs[1]
    x != x && return (x, x)
    return _extrema(f, (x, x), Base.tail(xs)...)
end
@inline _extrema(f, ans) = ans
@inline function _extrema(f::F, (l, g), x, xs...) where {F}
    x != x && return (x, x)
    return _extrema(f, (isless(x, l) ? x : l, isless(g, x) ? x : g), xs...)
end

@inline in(x, xs) = Base.in(x, xs)
@inline in(x) = Base.Fix2(in, x)
@inline Specialized.in(x) = Base.Fix2(Specialized.in, x)
@def in(x, xs::Tuple) = _any(==(x), xs...)

@inline unique(f, itr) = Base.unique(f, itr)
@inline unique(itr) = Base.unique(itr)
@def unique(xs::Tuple{}) = ()
@def unique(xs::Tuple) =
    afoldl((), xs...) do xs′, x
        x in xs′ ? xs′ : (xs′..., x)
    end
@def unique(f, xs::Tuple{}) = ()
@def function unique(f::F, xs::Tuple) where {F}
    ys = map(f, xs)
    xs′, = afoldl(((), ()), zip(xs, ys)...) do (xs, ys), (x, y)
        y in ys ? (xs, ys) : ((ys..., y), (xs..., x))
    end
    return xs′
end

@inline union(args...) = Base.union(args...)

@def union(a::Tuple) = Specialized.unique(a)
@def union(a::Tuple, b::Tuple) = unique((a..., b...))
@def union(a::Tuple, bs::Tuple...) = afoldl(union, a, bs...)

@inline intersect(s, itrs...) = Base.intersect(s, itrs...)
@def intersect(a::Tuple) = a
@def intersect(a::Tuple{}, b::Tuple{}) = ()
@def intersect(a::Tuple, b::Tuple{}) = ()
@def intersect(a::Tuple{}, b::Tuple) = ()
@def intersect(a::Tuple, b::Tuple) = unique(filter(x -> x in b, a))

@def intersect(a::Tuple, b::Tuple, cs::Tuple...) =
    foldl(Specialized.intersect, cs, init = Specialized.intersect(a, b))

@inline setdiff(args...) = Base.setdiff(args...)
@def setdiff(a::Tuple, b::Tuple{}) = a
@def setdiff(a::Tuple, b::Tuple) = setdiff(_exclude(a, b[1]), Base.tail(b))
@inline _exclude(a, b) = Base.foldl((ys, x) -> x == b ? ys : (ys..., x), a; init = ())

@def setdiff(a::Tuple, b::Tuple, cs::Tuple...) =
    Base.foldl(Specialized.setdiff, cs, init = Specialized.setdiff(a, b))

@def symdiff(a::Tuple, b::Tuple) =
    foldl(b; init = a) do a, x
        i = findfirst(==(x), a)
        i == nothing ? (a..., x) : _deleteat(a, i)
    end
@def symdiff(a::Tuple, b::Tuple, cs::Tuple...) =
    foldl(Specialized.symdiff, cs, init = Specialized.symdiff(a, b))

_deleteat(a, i::Int) =
    foldl(a; init = ((), 1)) do (ys, j), x
        ((i == j ? ys : (ys..., x)), j + 1)
    end

@inline issubset(a, b) = Base.issubset(a, b)
@def issubset(a::Tuple, b::Tuple) = Specialized.all(x -> x in b, a)

if VERSION >= v"1.5"
    @inline isdisjoint(a, b) = Base.isdisjoint(a, b)
else
    @inline isdisjoint(a, b) = isempty(intersect(a, b))
end
@def isdisjoint(a::Tuple, b::Tuple) = !Specialized.any(x -> x in b, a)

sort(v; kw...) = Base.sort(v; kw...)

@def sort(
    v::Tuple;
    lt = isless,
    by = identity,
    rev::Union{Bool,Nothing} = nothing,
    order = Base.Forward,
) = _sort(Base.ord(lt, by, rev, order), v)

@inline _sort(order, ::Tuple{}) = ()
@inline _sort(order, x::Tuple{Any}) = x
@inline _sort(order, (x, y)::Tuple{Any,Any}) = Base.lt(order, y, x) ? (y, x) : (x, y)
@inline function _sort(order, v)
    left, right = _halve(v)
    return _mergesorted(order, _sort(order, left), _sort(order, right))
end

@inline _mergesorted(order, ::Tuple{}, ::Tuple{}) = ()
@inline _mergesorted(order, ::Tuple{}, right) = right
@inline _mergesorted(order, left, ::Tuple{}) = left
@inline function _mergesorted(order, left, right)
    a = left[1]
    b = right[1]
    if Base.lt(order, b, a)
        return (b, _mergesorted(order, left, Base.tail(right))...)
    else
        return (a, _mergesorted(order, Base.tail(left), right)...)
    end
end

@inline function _halve(v::NTuple{N,Any}) where {N}
    m = N ÷ 2
    return (getindex(v, 1:m), getindex(v, m+1:N))
end

# Compilation takes too long (> 10 sec) for `length(v::Tuple) > 13`.
const Any14{N} =
    Tuple{Any,Any,Any,Any,Any,Any,Any,Any,Any,Any,Any,Any,Any,Any,Vararg{Any,N}}
@nospecialize
sort(v::Any14; kw...) = Tuple(Base.sort!(collect(v); kw...))
@specialize

module TestWithBase

using Base.Iterators: flatten
using Baselet
using Test

args_and_kwargs(args...; kwargs...) = args, (; kwargs...)

==ᶜ(x, y) = collect(x) == collect(y)

# Dummy implementations
accumulate(op, xs::Tuple; kw...) = Tuple(Base.accumulate(op, collect(xs); kw...))
cumsum(xs::Tuple) = Tuple(Base.cumsum(collect(xs)))
cumprod(xs::Tuple) = Tuple(Base.cumprod(collect(xs)))

raw_testdata_pure = """
getindex((100, 200, 300, 400), 2:3) ==
zip((11, 22, 33)) ==ᶜ
zip((11, 22, 33), (111, 222, 333)) ==ᶜ
accumulate(+, (11, 22, 33)) ===
accumulate(+, (11, 22, 33); init=100) ===
cumsum((11, 22, 33)) ===
cumprod((11, 22, 33)) ===
enumerate((11, 22, 33)) ==ᶜ
flatten(((11, 22), (33, 44, 55))) ==ᶜ
any((false, false, false)) ===
any((false, true, false)) ===
any((false, true, false, missing)) ===
any((false, false, false, missing)) ===
any(==(0), (10, 11, 12)) ===
any(==(10), (10, 11, 12)) ===
any(==(0), (10, 11, 12, missing)) ===
any(==(10), (10, 11, 12, missing)) ===
all((true, true, true)) ===
all((true, false, true)) ===
all((true, true, true, missing)) ===
all((true, false, true, missing)) ===
all(==(0), (10, 10, 10)) ===
all(==(10), (10, 10, 10)) ===
all(==(0), (10, 10, 10, missing)) ===
all(==(10), (10, 10, 10, missing)) ===
findfirst(()) ==
findfirst((false, true)) ==
findfirst((false, false)) ==
findfirst(==(10), ()) ==
findfirst(==(10), (11, 10, 10)) ==
findfirst(==(10), (11, 11, 11)) ==
findlast(()) ==
findlast((false, true)) ==
findlast((false, false)) ==
findlast(==(10), ()) ==
findlast(==(10), (11, 10, 10)) ==
findlast(==(10), (11, 11, 11)) ==
findall(()) ==ᶜ
findall((false, true)) ==ᶜ
findall((false, false)) ==ᶜ
findall(==(10), ()) ==ᶜ
findall(==(10), (11, 10, 10)) ==ᶜ
findall(==(10), (11, 11, 11)) ==ᶜ
findmax((1, 2, 3, 2, 3, 1)) ===
findmax((1, NaN, 2, 3, NaN, 2)) ===
findmin((1, 2, 3, 2, 3, 1)) ===
findmin((1, NaN, 2, 3, NaN, 2)) ===
argmax((1, 2, 3, 2, 3, 1)) ===
argmax((1, NaN, 2, 3, NaN, 2)) ===
argmin((1, 2, 3, 2, 3, 1)) ===
argmin((1, NaN, 2, 3, NaN, 2)) ===
maximum((1, 2, 3, 2, 3, 1)) ===
maximum((1, NaN, 2, 3, NaN, 2)) ===
minimum((1, 2, 3, 2, 3, 1)) ===
minimum((1, NaN, 2, 3, NaN, 2)) ===
extrema((1, 2, 3, 2, 3, 1)) ===
extrema((1, NaN, 2, 3, NaN, 2)) ===
in(1, (1, 2, 3)) ===
in(0, (1, 2, 3)) ===
in(0, (1, 2, 3, missing)) ===
in(1, (1, 2, 3, missing)) ===
in(missing, (missing,)) ===
in(NaN, (NaN,)) ===
in(0.0, (-0.0,)) ===
unique((11, 12, 13)) ==ᶜ
unique((11, 11, 11)) ==ᶜ
unique(abs, (11, -12, 13, 12)) ==ᶜ
unique(abs, (11, -11, 11)) ==ᶜ
union((11, 12, 13)) ==ᶜ
union((11, 12, 13), (12, 13)) ==ᶜ
union((11, 12, 13), (12, 13, 14), (15, 13, 12)) ==ᶜ
intersect((11, 12, 13)) ==ᶜ
intersect((11, 12, 13), (12, 13)) ==ᶜ
intersect((11, 12, 13), (12, 13, 14), (15, 13, 12)) ==ᶜ
setdiff((11, 12, 13), ()) ==ᶜ
setdiff((), (11, 12, 13)) ==ᶜ
setdiff((11, 12, 13), (12, 13)) ==ᶜ
setdiff((11, 12, 13), (12, 13, 14), (15, 13, 12)) ==ᶜ
"""

# An array of `(label, (f, args, kwargs, comparison))`
testdata_pure = map(split(raw_testdata_pure, "\n", keepempty = false)) do x
    f, rest = split(x, "(", limit = 2)
    input, comparison = rsplit(rest, ")", limit = 2)
    comparison = strip(comparison)
    ex = Meta.parse("DUMMY($input)")
    ex.args[1] = args_and_kwargs
    @eval ($x, ($(Symbol(f)), $ex..., $(Symbol(comparison))))
end

@testset "$label" for (label, (f, args, kwargs, ==′)) in testdata_pure
    Baselet_f = getproperty(Baselet, nameof(f))
    Specialized_f = getproperty(Baselet.Specialized, nameof(f))
    @test Baselet_f(args...; kwargs...) ==′ f(args...; kwargs...)
    @test Specialized_f(args...; kwargs...) ==′ f(args...; kwargs...)
    @test typeof(Baselet_f(args...; kwargs...)) == typeof(Specialized_f(args...; kwargs...))
end

function test_all_implementations(test)
    @testset for m in [Base, Baselet, Baselet.Specialized]
        test(m)
    end
end

@testset "foreach(x -> push!(xs, x), 1:5)" begin
    test_all_implementations() do m
        xs = Int[]
        m.foreach(1:5) do x
            push!(xs, x)
        end
        @test xs == 1:5
    end
end

@testset "foreach(x -> push!(xs, x), (1, 2, 3))" begin
    test_all_implementations() do m
        xs = Int[]
        m.foreach((1, 2, 3)) do x
            push!(xs, x)
        end
        @test xs == 1:3
    end
end

@testset "foreach((a, b) -> push!(xs, a + b), 1:5, 6:10)" begin
    test_all_implementations() do m
        xs = Int[]
        m.foreach(1:5, 6:10) do a, b
            push!(xs, a + b)
        end
        @test xs == 7:2:15
    end
end

@testset "foreach((a, b) -> push!(xs, a + b), (1, 2, 3), (6, 7, 8))" begin
    test_all_implementations() do m
        xs = Int[]
        m.foreach((1, 2, 3), (6, 7, 8)) do a, b
            push!(xs, a + b)
        end
        @test xs == 7:2:11
    end
end

end  # module

module Utils

using Base.Meta: isexpr
using ..Specialized

function spec_lhs_rhs(ex)
    if isexpr(ex, :where)
        lhs, rhs = spec_lhs_rhs(ex.args[1])
        return Expr(:where, lhs, ex.args[2:end]...), rhs
    elseif isexpr(ex, :call)
        f = ex.args[1]
        @assert f isa Symbol
        spec = Expr(:call, :($Specialized.$f), ex.args[2:end]...)
        @debug "@def -> spec_lhs_rhs" ex spec
        rhs = strip_typeassert(spec)
        if isexpr(get(rhs.args, 2, nothing), :parameters)
            rhs.args[2].args .= map(rhs.args[2].args) do x
                if isexpr(x, :kw)
                    Expr(:kw, x.args[1], x.args[1])
                else
                    x
                end
            end
        end
        return (spec, rhs)
    else
        error("Cannot handle expression: ", ex)
    end
end

function strip_typeassert(ex)
    if isexpr(ex, :(::))
        length(ex.args) == 2 ||
            error("argument name is required for `@def`. Got:\n", ex)
        return ex.args[1]
    elseif ex isa Expr
        return Expr(ex.head, map(strip_typeassert, ex.args)...)
    else
        return ex
    end
end

"""
    @def f(...) = ...
    @def function f(...) ... end

Expand function definition for function `f` to:

```julia
@inline \$f(...) = Specialized.\$f(...)
@inline Specialized.\$f(...) = ...
```
"""
macro def(ex)
    @assert ex.head in [:function, :(=)]
    @assert length(ex.args) == 2
    lhs, rhs = spec_lhs_rhs(ex.args[1])
    block = Expr(:block, __source__, rhs)
    quote
        @inline $(ex.args[1]) = $block
        @inline $lhs = $(ex.args[2])
    end |> esc
end

end  # module
using .Utils: @def

module TestSort

using Baselet.Specialized: sort
using Random: shuffle
using Test

@testset for n in 1:10
    one_to_n = ntuple(identity, n)
    @test sort(one_to_n) == one_to_n
    @test sort(one_to_n; by = first) == one_to_n
    @test sort(one_to_n; by = _ -> 1) == one_to_n  # stable sort
    @test sort(Tuple(shuffle(1:n))) == one_to_n
    @test sort(one_to_n; by = inv) == reverse(one_to_n)
    @test sort(Tuple(shuffle(1:n)); by = inv) == reverse(one_to_n)
end

end  # module

module TestBaselet
using Test

@testset "$file" for file in sort([
    file for file in readdir(@__DIR__) if match(r"^test_.*\.jl$", file) !== nothing
])
    # Skip inference test on Julia 1.0.  It may work in 1.1 or 1.2 but
    # they are note tested.
    if VERSION < v"1.3-" && file == "test_inference.jl"
        @info "Skip $file for Julia $VERSION"
        continue
    elseif (
        lowercase(get(ENV, "JULIA_PKGEVAL", "false")) == "true" &&
        file == "test_inference.jl"
    )
        @info "Skip $file on PkgEval."
        continue
    end
    include(file)
end

end  # module

module TestInference

using Baselet
using Test

valof(::Val{x}) where {x} = x

macro test_inferred(ex)
    quote
        f() = $(esc(ex))
        Test.@test Test.@inferred(f()) isa Any
    end
end

@testset "getindex" begin
    @test_inferred Baselet.getindex((Val(1), Val(2), Val(3), Val(4)), 2:3)
end

@testset "zip" begin
    @test_inferred Baselet.zip((Val(1), Val(2), Val(3), Val(4)))
    @test_inferred Baselet.zip(
        (Val(1), Val(2), Val(3), Val(4)),
        (Val(5), Val(6), Val(7), Val(8)),
    )
end

@testset "flatten" begin
    @test_inferred Baselet.flatten(((Val(1), Val(2)), (Val(3), Val(4), Val(5))))
end

@testset "enumerate" begin
    if VERSION >= v"1.6-"
        @info "Skip inference test for `enumerate` on Julia $VERSION"
    else
        @test_inferred Val(Baselet.enumerate((Val(1), Val(2), Val(3), Val(4))))
    end
end

@testset "any" begin
    @test_inferred Val(Baselet.any(valof, (Val(false), Val(false), Val(false))))
    @test_inferred Val(Baselet.any(valof, (Val(false), Val(false), Val(true))))
end

@testset "all" begin
    @test_inferred Val(Baselet.all(valof, (Val(true), Val(true), Val(true))))
    @test_inferred Val(Baselet.all(valof, (Val(true), Val(true), Val(false))))
end

@testset "sort" begin
    @test_inferred Baselet.sort((Val(3), Val(1), Val(2), Val(0)), by = valof)
end

end  # module
